/*
 * JBoss, the OpenSource EJB server
 *
 * Distributable under LGPL license.
 * See terms of license at gnu.org.
 */
package org.jboss.ejb3.test.entitycallback;

import javax.persistence.Entity;
import javax.persistence.Inheritance;
import javax.persistence.InheritanceType;
import javax.persistence.DiscriminatorType;
import javax.persistence.PrePersist;
import javax.persistence.PostPersist;
import javax.persistence.PreRemove;
import javax.persistence.PostRemove;
import javax.persistence.PreUpdate;
import javax.persistence.PostUpdate;
import javax.persistence.PostLoad;
import javax.persistence.Entity;

/**
 * @author <a href="mailto:kabir.khan@jboss.org">Kabir Khan</a>
 * @version $Revision: 1.4.2.4 $
 */
@Entity
@Inheritance(strategy = InheritanceType.SINGLE_TABLE, discriminatorType = DiscriminatorType.STRING, discriminatorValue = "TRAIN")
public class TrainJourney extends Journey
{
   private String train;

   public TrainJourney()
   {

   }

   public TrainJourney(String start, String dest, String train)
   {
      super(start, dest);
      this.train = train;
   }

   public String getTrain()
   {
      return train;
   }

   public void setTrain(String train)
   {
      this.train = train;
   }

   @PrePersist
   public void doPreCreate()
   {
      System.out.println("TrainJourney doPreCreate");
      CallbackCounterBean.addCallback("TrainJourney", PrePersist.class);
   }

   @PostPersist
   public void doPostCreate()
   {
      System.out.println("TrainJourney doPostCreate");
      CallbackCounterBean.addCallback("TrainJourney", PostPersist.class);
   }

   @PreRemove
   public void doPreRemove()
   {
      System.out.println("TrainJourney doPreRemove");
      CallbackCounterBean.addCallback("TrainJourney", PreRemove.class);
   }

   @PostRemove
   public void doPostRemove()
   {
      System.out.println("TrainJourney doPostRemove");
      CallbackCounterBean.addCallback("TrainJourney", PostRemove.class);
   }

   @PreUpdate
   public void doPreUpdate()
   {
      System.out.println("TrainJourney doPreUpdate");
      CallbackCounterBean.addCallback("TrainJourney", PreUpdate.class);
   }

   @PostUpdate
   public void doPostUpdate()
   {
      System.out.println("TrainJourney doPostUpdate");
      CallbackCounterBean.addCallback("TrainJourney", PostUpdate.class);
   }

   @PostLoad
   public void doPostLoad()
   {
      System.out.println("TrainJourney doPostLoad");
      CallbackCounterBean.addCallback("TrainJourney", PostLoad.class);
   }

}
